unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,dynlibs,ctypes,windows;

Const DLL_NAME = 'libtest.dll';

// externe Funktionen deklarieren
//function _extern_testfun(ii:clong):clong; cdecl; external DLL_NAME name 'extern_testfun';

type
  { TForm1 }
  my_type = longint;
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  procedure test_extern_testfun;
  //function Lextern_testfun(ii:my_type):my_type;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

Procedure TForm1.test_extern_testfun;

type Textern_testfun = function(ii: clong): clong; cdecl;

var MyHandle : TLibHandle = dynlibs.NilHandle;
    MyFunc   : Textern_testfun;

begin
 MyHandle:= loadlibrary(pchar('libtest.dll'));
 if MyHandle = dynlibs.NilHandle then begin
  memo1.lines.add('loadlibrary error: dynlib.Nilhandle');
 end
 else begin
   memo1.lines.add('loadlibrary OK');
   MyFunc := Textern_testfun(getprocedureaddress(MyHandle,'extern_testfun'));
   if assigned(MyFunc) then
    begin
    memo1.lines.add('getprocedureaddress OK');
    if MyFunc(123) = 123 then
     begin
      memo1.lines.add('extern_testfun OK');
     end;
    end
  else begin
    memo1.lines.add('Funktion nicht gefunden ');
  end;
 end;
FreeLibrary(MyHandle);
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
test_extern_testfun;
end;


end.

